﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Configuration;
using System.ComponentModel;

namespace DemoApp
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        const string BOMB_DATE = "bombDate";
        public MainWindow()
        {
            InitializeComponent();
            Loaded += OnWindowLoaded;
        }

        private void OnWindowLoaded(object sender, RoutedEventArgs e)
        {
            var q = ConfigurationManager.AppSettings.AllKeys.AsQueryable();
            var r = from c in q where c == BOMB_DATE select c;
            if (r.Count() > 0)
            {
                string datestr = ConfigurationManager.AppSettings[BOMB_DATE];
                picker.SelectedDate = DateTime.Parse(datestr);
            }
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            base.OnClosing(e);
            DateTime seldate = picker.SelectedDate ?? DateTime.Today;
            string forstr = seldate.ToShortDateString();
            // 当前exe的路径
            string exePath = Environment.GetCommandLineArgs()[0];
            // 打开配置文件
            Configuration config = ConfigurationManager.OpenExeConfiguration(exePath);
            // 设置值
            if (config.AppSettings.Settings.AllKeys.Count(s => s == BOMB_DATE) > 0)
            {
                // 如果设置项已经存在
                // 则直接修改
                var kv = config.AppSettings.Settings[BOMB_DATE];
                kv.Value = forstr;
            }
            else
            {
                // 如果设置项不存在
                // 则添加新项
                config.AppSettings.Settings.Add(BOMB_DATE, forstr);
            }
            // 保存
            if (config.AppSettings.SectionInformation.IsLocked)
            {
                // 如果配置节已锁定，则放弃保存
                return;
            }
            config.Save(ConfigurationSaveMode.Modified);
        }
    }
}
